'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _direction = require('direction');

var _direction2 = _interopRequireDefault(_direction);

var _immutable = require('immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var cache = {};

/**
 * Get direction of a text
 * @param  {String} text
 * @return {String} dir?
 */

function getDirection(text) {
    if (cache[text]) {
        return cache[text];
    }

    var dir = (0, _direction2.default)(text);
    if (dir === 'neutral') {
        return;
    }

    return dir;
}

var bidi = {
    getDirection: getDirection
};

exports.default = bidi;